#PDF_PI = 3.141593

Global pdfAngle.f

Procedure pdf_RotateBasic(angle.f, x.f, y.f) 
  If (x=-1) 
    x=pdf_GetX()
  EndIf 
  If (y=-1) 
    y=pdf_GetY()
  EndIf 
  If (pdfAngle <> 0) 
    ipf_Out("Q") 
  EndIf 
  pdfk.f = ipf_GetK()
  pdfH.f = ipf_GetH()
  pdfAngle = angle 
  If (angle<>0) 
    angle=angle*#PDF_PI/180 
    c.f = Cos(angle) 
    s.f = Sin(angle) 
    cx.f = x *  pdfk
    cy.f = (pdfH - y)*pdfk
    msg.s = "q " + StrF(c,5) + " " + StrF(s,5) + " " + StrF(-s,5) + " " + StrF(c,5) + " " + StrF(cx,2) + " " + StrF(cy,2)
    msg = msg + " cm 1 0 0 1 " + StrF(-cx,2) + " " + StrF(-cy,2) + " cm" 
    ipf_Out(msg)    
  EndIf 
EndProcedure 

Procedure angle_endpage()
	If(pdfAngle<>0)
		pdfAngle=0
		ipf_Out("Q")
	EndIf
EndProcedure

ProcedureDLL pdfDraw_Init()
  ipf_SetProcEndPage(@angle_endpage())
EndProcedure

ProcedureDLL pdf_Rotate(Angle.f)
  pdf_RotateBasic(angle, -1, -1) 
EndProcedure 

ProcedureDLL pdf_Rotate2(Angle.f, X.f)
  pdf_RotateBasic(angle, x, -1)
EndProcedure

ProcedureDLL pdf_Rotate3(Angle.f, X.f, Y.f)
  pdf_RotateBasic(angle.f, x, y)
EndProcedure

ProcedureDLL pdf_SetDash(Black.w, White.w)
  Protected s.s
  Protected k.f
  k = ipf_GetK()
  If (black <>0) And (white <> 0)
    s = "[" + StrF(black*k,3) + " " + StrF(white*k,3) + "] 0 d"
  Else
    s = "[] 0 d"
  EndIf
  ipf_Out(s)
EndProcedure

Procedure ipf_Arc(x1.f, y1.f, x2.f, y2.f, x3.f, y3.f)
  Protected h.f
  Protected k.f
  
  h = ipf_GetH()
  k = ipf_GetK()
  ipf_Out(StrF(x1*k,2) + " " + StrF((h-y1)*k,2) + " " + StrF(x2*k,2) + " " + StrF((h-y2)*k,2) + " " + StrF(x3*k,2) + " " + StrF((h-y3)*k,2) + " c")
EndProcedure

Procedure pdf_EllipseBasic(x.f, y.f, rx.f, ry.f, Style$)
  Protected op.s
  Protected lx.f, ly.f, k.f, h.f
  
  Select Style$
    Case #PDF_STYLE_FILL
      op = "f"
    Case #PDF_STYLE_DRAWANDFILL
      op = "B"
    Default:
      op = "S"
  EndSelect
  
  lx = 4/3*(Sqr(2)-1)*rx
  ly = 4/3*(Sqr(2)-1)*ry
  k = ipf_GetK()
  h = ipf_GetH()
  
  ipf_Out(StrF((x+rx)*k,2) + " " + StrF((h-y)*k,2) + " m " + StrF((x+rx)*k,2) + " " + StrF((h-y+ly)*k,2) + " " + StrF((x+lx)*k,2) + " " + StrF((h-y+ry) * k,2) + " " + StrF(x*k,2) + " " + StrF((h-y+ry)*k,2) + " c")
  ipf_Out(StrF((x-lx)*k,2) + " " + StrF((h-y+ry)*k,2) + " " + StrF((x-rx)*k,2) + " " + StrF((h-y+ly)*k,2) + " " +  StrF((x-rx)*k,2) + " " + StrF((h-y)*k,2) + " c")
  ipf_Out(StrF((x-rx)*k,2) + " " + StrF((h-y-ly)*k,2) + " " + StrF((x-lx)*k,2) + " " + StrF((h-y-ry)*k,2) + " " + StrF(x*k,2) + " " + StrF((h-y-ry) * k,2) + " c")
  ipf_Out(StrF((x+lx)*k,2) + " " + StrF((h-y-ry)*k,2) + " " + StrF((x+rx)*k,2) + " " + StrF((h-y-ly)*k,2) + " " + StrF((x+rx)*k,2) + " " + " " + StrF((h-y)*k,2) + " c " + op)
EndProcedure

Procedure pdf_CircleBasic(x.f, y.f, r.f, Style$)
  pdf_EllipseBasic(x, y, r, r, Style$)
EndProcedure

Procedure pdf_SectorBasic(xc.f, yc.f, r.f, a.w, b.w, Style$, cw.b, o.w)
  Protected op.s
  Protected k.f
  Protected MyArc.f, bf.f, af.f
  Protected d.f
  If cw = #True
    d = b
    b = o - a
    a = o - d
  Else
    b = b + o
    a = a + o
  EndIf
  a = (a%360) + 360
  b = (b%360) + 360
  If a > b
    b = b + 360
  EndIf
  bf = b/360*2*#PDF_PI
  af = a/360*2*#PDF_PI
  d = bf - af
  
  If d = 0
    d = 2 * #PDF_PI
  EndIf
  k = ipf_GetK()
  hp = ipf_GetH()
  Select Style$ 
    Case #PDF_STYLE_FILL
      op = "f"
    Case #PDF_STYLE_DRAWANDFILL
      op = "b"
    Default
      op = "s"
  EndSelect
  If Sin(d/2) 
    MyArc = 4/3*(1-Cos(d/2))/Sin(d/2)*r
  EndIf
  ;first put the center
  ipf_Out(StrF(xc*k,2) + " " + StrF((hp-yc)*k,2) + " m")
  ;put the first point
  ipf_Out(StrF((xc+r*Cos(af))*k,2) + " " + StrF((hp-(yc-r*Sin(af)))*k,2) + " l")
  ;draw the arc


  If ( d < (#PDF_PI/2)) 
    ipf_arc(xc+r*Cos(af)+MyArc*Cos(#PDF_PI/2+af), yc-r*Sin(af)-MyArc*Sin(#PDF_PI/2+af), xc+r*Cos(bf)+MyArc*Cos(bf-#PDF_PI/2), yc-r*Sin(bf)-MyArc*Sin(bf-#PDF_PI/2), xc+r*Cos(bf), yc-r*Sin(bf))
  Else
    bf = af + d/4
    MyArc = 4/3*(1-Cos(d/8))/Sin(d/8)*r     
    ipf_Arc(xc+r*Cos(af)+MyArc*Cos(#PDF_PI/2+af), yc-r*Sin(af)-MyArc*Sin(#PDF_PI/2+af), xc+r*Cos(bf)+MyArc*Cos(bf-#PDF_PI/2), yc-r*Sin(bf)-MyArc*Sin(bf-#PDF_PI/2), xc+r*Cos(bf), yc-r*Sin(bf))
    af = bf
    bf = af + d/4
    ipf_Arc(xc+r*Cos(af)+MyArc*Cos(#PDF_PI/2+af), yc-r*Sin(af)-MyArc*Sin(#PDF_PI/2+af), xc+r*Cos(bf)+MyArc*Cos(bf-#PDF_PI/2),yc-r*Sin(bf)-MyArc*Sin(bf-#PDF_PI/2),xc+r*Cos(bf), yc-r*Sin(bf))
    af = bf
    bf = af + d/4
    ipf_Arc(xc+r*Cos(af)+MyArc*Cos(#PDF_PI/2+af),yc-r*Sin(af)-MyArc*Sin(#PDF_PI/2+af),xc+r*Cos(bf)+MyArc*Cos(bf-#PDF_PI/2),yc-r*Sin(bf)-MyArc*Sin(bf-#PDF_PI/2),xc+r*Cos(bf),yc-r*Sin(bf))
    af= bf
    bf = af + d/4
    ipf_Arc(xc+r*Cos(af)+MyArc*Cos(#PDF_PI/2+af),yc-r*Sin(af)-MyArc*Sin(#PDF_PI/2+af),xc+r*Cos(bf)+MyArc*Cos(bf-#PDF_PI/2),yc-r*Sin(bf)-MyArc*Sin(bf-#PDF_PI/2),xc+r*Cos(bf),yc-r*Sin(bf))
  EndIf  
  ;terminate drawing
  ipf_Out(op)
EndProcedure

ProcedureDLL pdf_Ellipse(X.f, Y.f, Rx.f, Ry.f)
  pdf_EllipseBasic(x, y, rx, ry, #PDF_STYLE_DRAW)
EndProcedure

ProcedureDLL pdf_Ellipse2(X.f, Y.f, Rx.f, Ry.f, Style$)
  pdf_EllipseBasic(x, y, rx, ry, style$)
EndProcedure

ProcedureDLL pdf_Circle(X.f, Y.f, R.f)
  pdf_CircleBasic(x, y, r, #PDF_STYLE_DRAW)
EndProcedure

ProcedureDLL pdf_Circle2(X.f, Y.f, R.f, Style$)
  pdf_CircleBasic(x, y, r, style$)
EndProcedure

ProcedureDLL pdf_Sector(Xc.f, Yc.f, R.f, A.w, B.w)
  pdf_SectorBasic(xc, yc, r, a, b, #PDF_STYLE_DRAWANDFILL, #True, 90)
EndProcedure

ProcedureDLL pdf_Sector2(Xc.f, Yc.f, R.f, A.w, B.w, Style$)
  pdf_SectorBasic(xc, yc, r, a, b, style$, #True, 90)
EndProcedure

ProcedureDLL pdf_Sector3(Xc.f, Yc.f, R.f, A.w, B.w, Style$, Cw.b)
  pdf_SectorBasic(xc, yc, r, a, b, style$, cw, 90)
EndProcedure

ProcedureDLL pdf_Sector4(Xc.f, Yc.f, R.f, A.w, B.w, Style$, Cw.b, O.w)
  pdf_SectorBasic(xc, yc, r, a, b, style$, cw, o)
EndProcedure

ProcedureDLL pdf_StartTransform()
  ipf_Out("q")
EndProcedure

ProcedureDLL pdf_StopTransform()
  ipf_Out("Q")
EndProcedure

Procedure ipf_Transform(p1.f, p2.f, p3.f, p4.f, p5.f, p6.f)
  ipf_Out(StrF(p1,3) + " " + StrF(p2,3) + " " + StrF(p3,3) + " " + StrF(p4,3) + " " + StrF(p5,3) + " " + StrF(p6,3) + " cm")  
EndProcedure

Procedure pdf_ScaleBasic(SX.f, SY.f, X.f, Y.f)
  If (x=-1) 
    x=pdf_GetX()
  EndIf 
  If (y=-1) 
    y=pdf_GetY()
  EndIf 
  If (x=0) Or (y=0)    
    ProcedureReturn -1
  EndIf
  h.f = ipf_GetH()
  k.f = ipf_GetK()
  y = (h - y)*k
  x = x*k		
	;Calculate elements of transformation matrix
	SX = SX / 100
	SY = SY / 100  
	p1.f = SX
	p2.f = 0
	p3.f = 0
	p4.f = SY
	p5.f = x*(1-sx)
	p6.f = y*(1-sy)
	;Scale the coordinate system
	ipf_Transform(p1, p2, p3, p4, p5, p6)
EndProcedure

ProcedureDLL pdf_ScaleX(SX.f)
  pdf_ScaleBasic(sx, 100, -1, -1)
EndProcedure

ProcedureDLL pdf_ScaleX2(SX.f, X.f)
  pdf_ScaleBasic(sx, 100, X, -1)
EndProcedure

ProcedureDLL pdf_ScaleX3(SX.f, X.f, Y.f)
  pdf_ScaleBasic(sx, 100, X, Y)
EndProcedure

ProcedureDLL pdf_ScaleY(SY.f)
  pdf_ScaleBasic(100, SY, -1, -1)
EndProcedure

ProcedureDLL pdf_ScaleY2(SY.f, X.f)
  pdf_ScaleBasic(100, SY, X, -1)
EndProcedure

ProcedureDLL pdf_ScaleY3(SY.f, X.f, Y.f)
  pdf_ScaleBasic(100, SY, X, Y)
EndProcedure

ProcedureDLL pdf_ScaleXY(S.f)
  pdf_ScaleBasic(S, S, -1, -1)
EndProcedure

ProcedureDLL pdf_ScaleXY2(S.f, X.f)
  pdf_ScaleBasic(S, S, X, -1)
EndProcedure

ProcedureDLL pdf_ScaleXY3(S.f, X.f, Y.f)
  pdf_ScaleBasic(S, S, X, Y)
EndProcedure

ProcedureDLL pdf_MirrorH()
  pdf_ScaleBasic(-100,100,-1,-1)
EndProcedure

ProcedureDLL pdf_MirrorH2(X.f)
  pdf_ScaleBasic(-100,100,X,-1)
EndProcedure

ProcedureDLL pdf_MirrorV()
  pdf_ScaleBasic(100,-100,-1,-1)
EndProcedure

ProcedureDLL pdf_MirrorV2(Y.f)
  pdf_ScaleBasic(100,-100,-1,Y)
EndProcedure

Procedure pdf_TranslateBasic(TX.f, TY.f)
  p1.f = 1
  p2.f = 0
  p3.f = 0
  p4.f = 1
  p5.f = TX
  p6.f = TY
  ipf_Transform(p1, p2, p3, p4, p5, p6)
EndProcedure

ProcedureDLL pdf_Translate(TX.f, TY.f)
  pdf_TranslateBasic(TX, TY)
EndProcedure

ProcedureDLL pdf_TranslateX(TX.f)
  pdf_TranslateBasic(TX,0)
EndProcedure

ProcedureDLL pdf_TranslateY(TY.f)
  pdf_TranslateBasic(0,TY)
EndProcedure

Procedure pdf_SkewBasic(AngleX.f, AngleY.f, X.f, Y.f)
  If (x=-1) 
    x=pdf_GetX()
  EndIf 
  If (y=-1) 
    y=pdf_GetY()
  EndIf 
  If (AngleX<=-90) Or (AngleX>=90) Or (AngleY<=-90) Or (AngleY>=90)   
    ProcedureReturn -1
  EndIf
  h.f = ipf_GetH()
  k.f = ipf_GetK()
  y = (h - y)*k
  x = x*k		
	;Calculate elements of transformation matrix 
	p1.f = 1
	p2.f = Tan(AngleY*#PDF_PI/180)
	p3.f = Tan(AngleX*#PDF_PI/180)
	p4.f = 1
	p5.f = -y*(p3)
	p6.f = -x*(p2)
	;Scale the coordinate system
	ipf_Transform(p1, p2, p3, p4, p5, p6)
EndProcedure

ProcedureDLL pdf_Skew(AngleX.f, AngleY)
  pdf_skewBasic(AngleX, AngleY, -1, -1)
EndProcedure

ProcedureDLL pdf_Skew2(AngleX.f, AngleY, X.f)
  pdf_skewBasic(AngleX, AngleY, X, -1)
EndProcedure

ProcedureDLL pdf_Skew3(AngleX.f, AngleY, X.f, Y.f)
  pdf_skewBasic(AngleX, AngleY, X, Y)
EndProcedure

ProcedureDLL pdf_SkewX(AngleX)
  pdf_SkewBasic(AngleX,0,-1,-1)
EndProcedure

ProcedureDLL pdf_SkewX2(AngleX, X.f)
  pdf_SkewBasic(AngleX,0,X,-1)
EndProcedure

ProcedureDLL pdf_SkewX3(AngleX, X.f, Y.f)
  pdf_SkewBasic(AngleX,0,X,Y)
EndProcedure

ProcedureDLL pdf_SkewY(AngleY)
  pdf_SkewBasic(0,AngleY,-1,-1)
EndProcedure

ProcedureDLL pdf_SkewY2(AngleY, X.f)
  pdf_SkewBasic(0,AngleY,X,-1)
EndProcedure

ProcedureDLL pdf_SkewY3(AngleY, X.f, Y.f)
  pdf_SkewBasic(0,AngleY,X,Y)
EndProcedure
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 350
; FirstLine = 335
; Folding = ---------